﻿Option Strict On
Imports Windows.UI.Input.Inking
Imports Windows.UI.Input
Imports Windows.Devices.Input
Imports Windows.UI
Imports Windows.UI.Xaml.Shapes

' 空白ページのアイテム テンプレートについては、http://go.microsoft.com/fwlink/?LinkId=234238 を参照してください

''' <summary>
''' それ自体で使用できる空白ページまたはフレーム内に移動できる空白ページ。
''' </summary>
Public NotInheritable Class MainPage
    Inherits Page

    ''' <summary>
    ''' このページがフレームに表示されるときに呼び出されます。
    ''' </summary>
    ''' <param name="e">このページにどのように到達したかを説明するイベント データ。Parameter 
    ''' プロパティは、通常、ページを構成するために使用します。</param>
    ''' 
    Dim prevContactPoint As Point
    Dim myInkManager As New InkManager
    Dim myPenID As UInteger
    Dim currentContactPoint As Point
    Dim x1 As Double
    Dim x2 As Double
    Dim y1 As Double
    Dim y2 As Double
    Protected Overrides Sub OnNavigatedTo(e As Navigation.NavigationEventArgs)
        recognizeButton.IsEnabled = False
        AddHandler myCanvas.PointerPressed, AddressOf myCanvas_PointerPressed
        AddHandler myCanvas.PointerMoved, AddressOf myCanvas_PointerMoved
        AddHandler myCanvas.PointerReleased, AddressOf myCanvas_PointerReleased
        AddHandler myCanvas.PointerExited, AddressOf myCanvas_PointerReleased
    End Sub

    Private Sub myCanvas_PointerPressed(sender As Object, e As PointerRoutedEventArgs)
        Try
            Dim myPointer As PointerPoint = e.GetCurrentPoint(myCanvas)
            prevContactPoint = myPointer.Position
            Dim myPointerDevType As PointerDeviceType = e.Pointer.PointerDeviceType
            If myPointerDevType = PointerDeviceType.Pen Or myPointerDevType = PointerDeviceType.Mouse Or myPointerDevType = PointerDeviceType.Touch And myPointer.Properties.IsLeftButtonPressed = True Then
                myInkManager.ProcessPointerDown(myPointer)
                myPenID = myPointer.PointerId
                e.Handled = True
            End If
        Catch
            Exit Sub
        End Try
    End Sub


    Private Sub myCanvas_PointerMoved(sender As Object, e As PointerRoutedEventArgs)
        If e.Pointer.PointerId = myPenID Then
            recognizeButton.IsEnabled = True
            Dim myPointer As PointerPoint = e.GetCurrentPoint(myCanvas)
            currentContactPoint = myPointer.Position
            x1 = prevContactPoint.X
            y1 = prevContactPoint.Y
            x2 = currentContactPoint.X
            y2 = currentContactPoint.Y
            Dim myLine As New Line
            With myLine
                .X1 = x1
                .Y1 = y1
                .X2 = x2
                .Y2 = y2
                .StrokeThickness = 5
                .Stroke = New SolidColorBrush(Colors.Red)
            End With
            prevContactPoint = currentContactPoint
            myCanvas.Children.Add(myLine)
            myInkManager.ProcessPointerUpdate(myPointer)
        End If
        e.Handled = True
    End Sub

    Private Sub myCanvas_PointerReleased(sender As Object, e As PointerRoutedEventArgs)
        If e.Pointer.PointerId = myPenID Then
            Dim myPointer As PointerPoint = e.GetCurrentPoint(myCanvas)
            myInkManager.ProcessPointerUp(myPointer)
        End If
        myPenID = 0
        e.Handled = True
    End Sub

    Private Sub clearButton_Click(sender As Object, e As RoutedEventArgs) Handles clearButton.Click
        TextBox1.Text = String.Empty
        myInkManager.Mode = InkManipulationMode.Erasing
        Dim myStroke As IReadOnlyList(Of InkStroke) = myInkManager.GetStrokes
        For i As Integer = 0 To myStroke.Count - 1
            myStroke(i).Selected = True
        Next
        myInkManager.DeleteSelected()
        myCanvas.Background = New SolidColorBrush(Colors.White)
        myCanvas.Children.Clear()
        myInkManager.Mode = InkManipulationMode.Inking
        recognizeButton.IsEnabled = False
    End Sub

    Private Async Sub recognizeButton_Click(sender As Object, e As RoutedEventArgs) Handles recognizeButton.Click
        Dim myStroke = myInkManager.GetStrokes
        For i As Integer = 0 To myStroke.Count - 1
            myStroke(i).Selected = True
        Next

        Dim myRecName = "Microsoft 日本語手書き認識エンジン"
        Dim myRecognizer As IReadOnlyList(Of InkRecognizer) = myInkManager.GetRecognizers

        For i As Integer = 0 To myRecognizer.Count - 1
            If myRecName = myRecognizer(i).Name Then
                myInkManager.SetDefaultRecognizer(myRecognizer(i))
            End If

        Next

        Dim result As IReadOnlyList(Of InkRecognitionResult) = Await myInkManager.RecognizeAsync(InkRecognitionTarget.All)
        myInkManager.UpdateRecognitionResults(result)

        Dim myAlternate = String.Empty
        For Each myResult In result
            Dim myText = myResult.GetTextCandidates
            myAlternate = myAlternate & " " & myText(0)
            TextBox1.Text = myAlternate
        Next
    End Sub
End Class
